var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { useContext, useRef } from 'react';
import { StyleContext } from '../provider';
import { usePrevious } from './use-previous';
import { isShallowEqual } from '../utils';
/**
 * Use styles form stylesheet
 */
var useStyles = function (_a, props) {
    var dynamic = _a.dynamic, _b = _a.staticStyles, staticStyles = _b === void 0 ? {} : _b;
    var _c = useContext(StyleContext), theme = _c.theme, needToRecalculate = _c.needToRecalculate;
    var previousNeedToRecalculate = usePrevious(needToRecalculate);
    var previousTheme = usePrevious(theme);
    var previousProps = usePrevious(props);
    var getDynamicStyles = function () { return (dynamic ? dynamic(theme, props) : {}); };
    var getFullStyles = function () { return (__assign(__assign({}, staticStyles), getDynamicStyles())); };
    var styles = useRef({});
    var refresh = function () {
        styles.current = getFullStyles();
    };
    if ((previousProps && !props) ||
        !isShallowEqual(previousProps, props) ||
        theme != previousTheme ||
        needToRecalculate != previousNeedToRecalculate) {
        refresh();
    }
    return styles.current;
};
export { useStyles };
//# sourceMappingURL=use-styles.js.map