import { define } from '../define';
import { mount } from 'enzyme';
import { useStyles } from './use-styles';
import * as React from 'react';
import { Provider, StyleContext } from '../provider';
var mockStyles = function (primary, background, width) {
    if (width === void 0) { width = 10; }
    return ({
        root: {
            color: primary,
            backgroundColor: background,
            width: width
        }
    });
};
var styleSheet = define(function (_a, props) {
    var primary = _a.primary;
    return mockStyles(primary, props ? props.background : 'tomato');
});
var Hook = function (_a) {
    var on = _a.on, hook = _a.hook, use = _a.use;
    on(hook.apply(void 0, use));
    return null;
};
var Full = function (_a) {
    var primary = _a.primary, background = _a.background, _b = _a.props, props = _b === void 0 ? true : _b, _c = _a.on, on = _c === void 0 ? function (value) { } : _c, _d = _a.consume, consume = _d === void 0 ? function (value) { return null; } : _d;
    return (React.createElement(Provider, { theme: { primary: primary } },
        React.createElement(Hook, { on: on, use: [styleSheet, props ? { background: background } : null], hook: useStyles }),
        React.createElement(StyleContext.Consumer, null, consume)));
};
describe('useStyles()', function () {
    it('Should render styles', function () {
        var styles;
        var recalculate;
        var result = mount(React.createElement(Full, { on: function (value) { return (styles = value); }, consume: function (value) { return (recalculate = value.recalculate); }, primary: 'green', background: 'red' }));
        expect(styles).toEqual(mockStyles('green', 'red'));
        result.setProps({ primary: 'blue' });
        expect(styles).toEqual(mockStyles('blue', 'red'));
        result.setProps({ background: 'black' });
        expect(styles).toEqual(mockStyles('blue', 'black'));
        recalculate();
        expect(styles).toEqual(mockStyles('blue', 'black'));
        result.setProps({ props: false });
        expect(styles).toEqual(mockStyles('blue', 'tomato'));
    });
});
//# sourceMappingURL=use-styles.spec.js.map