import * as React from 'react';
import { ProviderProps } from './provider.props';
declare type Context = {
    theme: any;
    needToRecalculate: boolean;
    recalculate: () => any;
};
/**
 * Style context
 */
declare const StyleContext: React.Context<Context>;
/**
 * Provider
 */
declare const Provider: React.FC<ProviderProps>;
/**
 * Recalculate subscription definition
 */
declare const RecalculateSubscription: React.FC<{
    on: (recalculate: Context['recalculate']) => any;
    off: (recalculate: Context['recalculate']) => any;
}>;
/**
 * Subscribe to dimensions change and it will call recalculate styles from context
 */
declare const DimensionsSubscribtion: React.FC;
export { Provider, StyleContext, RecalculateSubscription, DimensionsSubscribtion };
