import * as React from 'react';
import { createContext, useContext, useEffect, useState } from 'react';
import { Dimensions } from 'react-native';
/**
 * Style context
 */
var StyleContext = createContext(null);
/**
 * Provider
 */
var Provider = function (_a) {
    var children = _a.children, theme = _a.theme;
    var _b = useState(false), needToRecalculate = _b[0], recalculate = _b[1];
    return (React.createElement(StyleContext.Provider, { value: {
            theme: theme,
            recalculate: function () { return recalculate(!needToRecalculate); },
            needToRecalculate: needToRecalculate
        } }, children));
};
/**
 * Recalculate subscription definition
 */
var RecalculateSubscription = function (_a) {
    var on = _a.on, off = _a.off;
    var context = useContext(StyleContext);
    useEffect(function () {
        on(context.recalculate);
        return function () { return off(context.recalculate); };
    }, []);
    return null;
};
/**
 * Subscribe to dimensions change and it will call recalculate styles from context
 */
var DimensionsSubscribtion = function () { return (React.createElement(RecalculateSubscription, { on: function (recalculate) { return Dimensions.addEventListener('change', recalculate); }, off: function (recalculate) { return Dimensions.removeEventListener('change', recalculate); } })); };
export { Provider, StyleContext, RecalculateSubscription, DimensionsSubscribtion };
//# sourceMappingURL=provider.component.js.map