import { ViewStyle, TextStyle, ImageStyle } from 'react-native';
/**
 * Object with styles defs
 */
declare type Styles = {
    [x: string]: ViewStyle | TextStyle | ImageStyle;
};
/**
 * Style definition required for use styles hook
 */
declare type StyleDefinition<D extends Styles, B extends Styles> = {
    dynamic: (theme: any, props: any) => D;
    staticStyles: B;
};
export { Styles, StyleDefinition };
